# Generated by Django 5.0.8 on 2025-02-17 13:50

from django.db import migrations, models

from arkindex.ponos.models import token_default


def add_agent_tokens(apps, schema_editor):
    Agent = apps.get_model("ponos", "Agent")
    to_update = []
    for agent in Agent.objects.filter(token=None).only("id").iterator():
        agent.token = token_default()
        to_update.append(agent)
    Agent.objects.bulk_update(to_update, ["token"], batch_size=100)


class Migration(migrations.Migration):

    dependencies = [
        ("ponos", "0014_task_task_finished_requires_final_state"),
    ]

    operations = [
        migrations.AddField(
            model_name="agent",
            name="token",
            field=models.CharField(
                max_length=52,
                # Make the field temporarily nullable and not unique, so that we can
                # fill the tokens on existing agents before adding the constraints.
                null=True,
            ),
        ),
        migrations.RunPython(
            add_agent_tokens,
            reverse_code=migrations.RunPython.noop,
        ),
    ]
