import django.core.validators
from django.db import migrations, models

import arkindex.process.models
import arkindex.project.fields


class Migration(migrations.Migration):
    dependencies = [
        ("process", "0028_remove_process_model_remove_process_test_folder_and_more"),
    ]

    operations = [
        migrations.AddField(
            model_name="processdataset",
            name="sets",
            field=arkindex.project.fields.ArrayField(base_field=models.CharField(max_length=50), blank=True, default=list, size=None),
        ),
        migrations.RunSQL(
            [
                """
                UPDATE process_processdataset p
                SET sets = d.sets
                FROM training_dataset d
                WHERE p.dataset_id = d.id
                """
            ],
            reverse_sql=migrations.RunSQL.noop,
            elidable=True,
        ),
        migrations.AlterField(
            model_name="processdataset",
            name="sets",
            field=arkindex.project.fields.ArrayField(
                base_field=models.CharField(
                    max_length=50,
                    validators=[django.core.validators.MinLengthValidator(1)]
                ),
                size=None,
                validators=[django.core.validators.MinLengthValidator(1), arkindex.process.models.validate_unique_set_names]
            ),
        ),
    ]
