SAVEPOINT "{savepoint}";

WITH parent_paths AS
    (SELECT path
     FROM documents_elementpath
     WHERE element_id = '{A}'::uuid
     ORDER BY path),
     child_paths AS
    (SELECT path
     FROM documents_elementpath
     WHERE element_id = '{B}'::uuid )
SELECT EXISTS
    (SELECT 1
     FROM child_paths),
    (SELECT path
     FROM child_paths
     WHERE path <> '{{}}'::uuid[]
     LIMIT 1), EXISTS
    (SELECT 1
     FROM child_paths
     WHERE path @> ARRAY['{A}'::uuid]), EXISTS
    (SELECT 1
     FROM parent_paths
     WHERE path @> ARRAY['{B}'::uuid]),
    (SELECT COUNT(*)
     FROM parent_paths),
    (SELECT path
     FROM parent_paths
     LIMIT 1),
    (SELECT COALESCE(MAX(ordering) + 1, 0)
     FROM documents_elementpath
     WHERE path @> ARRAY['{A}'::uuid]
         AND path[array_length(path, 1)] = '{A}'::uuid ) ;

INSERT INTO documents_elementpath (id, element_id, path, ordering)
SELECT gen_random_uuid(),
       '{B}'::uuid,
       path || '{A}'::uuid,
               1
FROM documents_elementpath
WHERE element_id = '{A}'::uuid ;

INSERT INTO documents_elementpath (id, element_id, path, ordering)
SELECT gen_random_uuid(),
       child_paths.element_id,
       new_parent_paths.path || '{A}'::uuid || child_paths.path[2:],
       child_paths.ordering
FROM documents_elementpath child_paths,
     documents_elementpath new_parent_paths
WHERE child_paths.path @> '{{{K},{B}}}'::uuid[]
    AND new_parent_paths.element_id = '{A}'::uuid ;

RELEASE SAVEPOINT "{savepoint}"
