SELECT "documents_element"."id"
FROM "documents_element"
WHERE "documents_element"."id" IN
        (SELECT U0."path"[array_length(U0."path", 1)]
         FROM "documents_elementpath" U0
         WHERE U0."element_id" = '{source_id}'::uuid);

SAVEPOINT "{savepoints[0]}";

SELECT COUNT(*) FILTER (
                        WHERE path[array_length(path, 1)] = '{parent_id}'::uuid),
                COUNT(*) FILTER (
                                 WHERE path[array_length(path, 1)] <> '{parent_id}'::uuid),
    (SELECT path
     FROM documents_elementpath
     WHERE element_id = '{source_id}'::uuid
         AND path[array_length(path, 1)] = '{parent_id}'::uuid
     LIMIT 1)
FROM documents_elementpath
WHERE element_id = '{source_id}'::uuid ;

UPDATE documents_elementpath
SET path = path[2:]
WHERE path @> '{{{parent_id},{source_id}}}'::uuid[]
    AND path[0:2] = '{{{parent_id},{source_id}}}'::uuid[] ;

UPDATE "documents_elementpath"
SET "path" = '{{}}'::uuid[]
WHERE ("documents_elementpath"."element_id" = '{source_id}'::uuid
       AND "documents_elementpath"."path" = (ARRAY['{parent_id}'::uuid])::uuid[]);

RELEASE SAVEPOINT "{savepoints[0]}";

SAVEPOINT "{savepoints[1]}";

WITH parent_paths AS
    (SELECT path
     FROM documents_elementpath
     WHERE element_id = '{destination_id}'::uuid
     ORDER BY path),
     child_paths AS
    (SELECT path
     FROM documents_elementpath
     WHERE element_id = '{source_id}'::uuid )
SELECT EXISTS
    (SELECT 1
     FROM child_paths),
    (SELECT path
     FROM child_paths
     WHERE path <> '{{}}'::uuid[]
     LIMIT 1), EXISTS
    (SELECT 1
     FROM child_paths
     WHERE path @> ARRAY['{destination_id}'::uuid]), EXISTS
    (SELECT 1
     FROM parent_paths
     WHERE path @> ARRAY['{source_id}'::uuid]),
    (SELECT COUNT(*)
     FROM parent_paths),
    (SELECT path
     FROM parent_paths
     LIMIT 1),
    (SELECT COALESCE(MAX(ordering) + 1, 0)
     FROM documents_elementpath
     WHERE path @> ARRAY['{destination_id}'::uuid]
         AND path[array_length(path, 1)] = '{destination_id}'::uuid ) ;

UPDATE "documents_elementpath"
SET "path" = '{{{destination_id}}}'::uuid[]::uuid[], "ordering" = 3
WHERE ("documents_elementpath"."element_id" = '{source_id}'::uuid
       AND "documents_elementpath"."path" = '{{}}'::uuid[]);

UPDATE "documents_elementpath"
SET "path" = array_cat('{{{destination_id}}}'::uuid[], "documents_elementpath"."path")::uuid[]
WHERE "documents_elementpath"."path" && (ARRAY['{source_id}'::uuid])::uuid[];

RELEASE SAVEPOINT "{savepoints[1]}"
